﻿// <auto-generated />
using System;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Metadata;
using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using WebApplication_ProjFinal.Models;

#nullable disable

namespace WebApplication_ProjFinal.Migrations
{
    [DbContext(typeof(DefaultDbContext))]
    [Migration("20230405135547_boolConnectedSubscriber")]
    partial class boolConnectedSubscriber
    {
        /// <inheritdoc />
        protected override void BuildTargetModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("ProductVersion", "7.0.4")
                .HasAnnotation("Relational:MaxIdentifierLength", 128);

            SqlServerModelBuilderExtensions.UseIdentityColumns(modelBuilder);

            modelBuilder.Entity("SubscriberTwitcher", b =>
                {
                    b.Property<int>("SubscribersId")
                        .HasColumnType("int");

                    b.Property<int>("TwitchersId")
                        .HasColumnType("int");

                    b.HasKey("SubscribersId", "TwitchersId");

                    b.HasIndex("TwitchersId");

                    b.ToTable("SubscriberTwitcher");
                });

            modelBuilder.Entity("twitch.api.Gift", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int");

                    SqlServerPropertyBuilderExtensions.UseIdentityColumn(b.Property<int>("Id"));

                    b.Property<DateTime>("Created")
                        .HasColumnType("datetime2");

                    b.Property<string>("Description")
                        .IsRequired()
                        .HasColumnType("nvarchar(max)");

                    b.Property<string>("Discriminator")
                        .IsRequired()
                        .HasColumnType("nvarchar(max)");

                    b.Property<int?>("SubscriberId")
                        .HasColumnType("int");

                    b.Property<int>("TwitcherId")
                        .HasColumnType("int");

                    b.HasKey("Id");

                    b.HasIndex("SubscriberId");

                    b.HasIndex("TwitcherId");

                    b.ToTable("gifts");

                    b.HasDiscriminator<string>("Discriminator").HasValue("Gift");

                    b.UseTphMappingStrategy();
                });

            modelBuilder.Entity("twitch.api.Subscriber", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int");

                    SqlServerPropertyBuilderExtensions.UseIdentityColumn(b.Property<int>("Id"));

                    b.Property<string>("Email")
                        .IsRequired()
                        .HasColumnType("nvarchar(max)");

                    b.Property<bool>("IsConnected")
                        .HasColumnType("bit");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("nvarchar(max)");

                    b.HasKey("Id");

                    b.ToTable("subscribers");
                });

            modelBuilder.Entity("twitch.api.Twitcher", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int");

                    SqlServerPropertyBuilderExtensions.UseIdentityColumn(b.Property<int>("Id"));

                    b.Property<string>("Email")
                        .IsRequired()
                        .HasColumnType("nvarchar(max)");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("nvarchar(max)");

                    b.HasKey("Id");

                    b.ToTable("twitchers");
                });

            modelBuilder.Entity("twitch.api.GDiscount", b =>
                {
                    b.HasBaseType("twitch.api.Gift");

                    b.HasDiscriminator().HasValue("GDiscount");
                });

            modelBuilder.Entity("twitch.api.GLearn", b =>
                {
                    b.HasBaseType("twitch.api.Gift");

                    b.HasDiscriminator().HasValue("GLearn");
                });

            modelBuilder.Entity("twitch.api.GOffer", b =>
                {
                    b.HasBaseType("twitch.api.Gift");

                    b.HasDiscriminator().HasValue("GOffer");
                });

            modelBuilder.Entity("twitch.api.GShare", b =>
                {
                    b.HasBaseType("twitch.api.Gift");

                    b.HasDiscriminator().HasValue("GShare");
                });

            modelBuilder.Entity("SubscriberTwitcher", b =>
                {
                    b.HasOne("twitch.api.Subscriber", null)
                        .WithMany()
                        .HasForeignKey("SubscribersId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("twitch.api.Twitcher", null)
                        .WithMany()
                        .HasForeignKey("TwitchersId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("twitch.api.Gift", b =>
                {
                    b.HasOne("twitch.api.Subscriber", "Subscriber")
                        .WithMany("Gifts")
                        .HasForeignKey("SubscriberId");

                    b.HasOne("twitch.api.Twitcher", "Twitcher")
                        .WithMany("Gifts")
                        .HasForeignKey("TwitcherId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("Subscriber");

                    b.Navigation("Twitcher");
                });

            modelBuilder.Entity("twitch.api.Subscriber", b =>
                {
                    b.Navigation("Gifts");
                });

            modelBuilder.Entity("twitch.api.Twitcher", b =>
                {
                    b.Navigation("Gifts");
                });
#pragma warning restore 612, 618
        }
    }
}
